# barker_v1_1.py
# (todolist) 
# objectives:
# - On cree un objet ayant un tableau de roues (avec leur taille:
#   des le demarrage)
#   on stocke dedans beaucoup de chose
# BUG: division par zero pour calcul Pin si deja fait !!!!
# - On divise calcule des Freq en deux: "a" et "b" (par rapport a une
#   autre roue dont on est "presque" sur des attributions "X/Y".
#   (ajouter dans imprHisto un parametre pour l'affichage (a,b, ...)
# - Ajouter le report des valeurs X/Y en fin de calFreq2W()
#   verifier les differences avant (ou apres) le report.
# - Modifier la saisie des Pins (conserve|modifie)
# - Ajouter la saisie (lecture?) de la proba du plain text
# - Memoriser un etat pour chaque roue
# - Mettre les Debug vraiement utiles
# - A priori supprimer le calcul auto (?) et ajouter mise a jour ETAT
#   (mais ajouter dans le menu une lettre pour indiquer l'etat de toutes
#   roues)
# - Verifier si mes calculs (pourcentage) sont corrects ou si il faut
#   les remplacer par une valeur superieure a ????
# - Ajouter une sauvegarde de la configuration des Pins ????
# --------
# - On remet le calcul auto
# - On teste sur un texte tres tres long
# - On verifie l'automate a etat fini
# - On verifie le coeur du programme :

import sys
import string
import copy

#=======================  Variables ======================
LEN_ALPHA = 26
#======================== Functions ======================
# ---- Print a Column 
def impr( tb ):
    print ' ',
    for i in range( WHEEL_SIZE ):
        print i % 10,
    print
    for i in range( LEN_ALPHA ):
        print string.uppercase[i],
        for j in range( WHEEL_SIZE ):
            if tb[j][i] == 0:
                print '-',
            else:
                print tb[j][i],
        print
    print
# ---- merge alphabets
def addAlpha( t1, t2 ):
    for i in range(26):
        t1[i] += t2[i]
    return t1

# ---- Print Frequencies of letters of a Column
def imprHisto( tb, car ):
    print "%1c" % car,
    print " A  B  C  D  E  F  G  H  I  J  K  L  M  N  O  P  Q  R  S  T  U  V  W  X  Y  Z"
    print " ",
    for letter in range( LEN_ALPHA ):
        if tb[letter] != 0:
            print "%2d" % (tb[letter]),
        else:
            print "  ",
    print

# ---- Chi2 calculation
def chi2( t1, t2):
    N1 = N2 = Scp = 0
    for i in range(26):
        N1  += t1[i]
        N2  += t2[i]
        Scp += t1[i] * t2[i]
    if (N1 == 0) or (N2 == 0): return 0
    return Scp / float( N1 * N2 )

# --- calculate the Shift between X and Y (then calculate "Kicks")
def theShift(tba, tbb, DEBUG):
    t1 = copy.deepcopy( tba )
    t2 = copy.deepcopy( tbb )
    imprHisto( t1, " " )
    imprHisto( t2, " " )
    bestVal = 0 ; bestIndx = 0
    for i in range(26):
        result = chi2( t1, t2)
        if result > bestVal:
            bestVal = result ; bestIndx = i
        if DEBUG:
            print "%3d : %10.6f" % (i, result )
        #print t2
        t2 = rotate( t2 )
    print "Index: ", bestIndx, " (", (26-bestIndx)%26, 
    print ") Best Chi2: ", bestVal

# --- rotate a list (for example, the frequencies of a column)
def rotate(lst):
    return lst[1:] + lst[:1]

# --- getV (used with sort function)
def getV(v): return v[1]

#======================== Classes ==========================
class WHEEL:
    def __init__(self, size ):
        self.WHEEL_SIZE = size
        self.Freq = {}
        for i in range( self.WHEEL_SIZE ):
            v = list( [0] * LEN_ALPHA  )
            self.Freq[str(i)] = v
        self.PinXY = [ ["?"]*self.WHEEL_SIZE, [0]*self.WHEEL_SIZE ]
        self.Chi2 = {}
        self.STATE = [0]*3

    def getSize(self):
        return self.WHEEL_SIZE

class Barker:
    def __init__(self, DEBUG):
        print "ok"
        self.setWheels( "26:25:23:21:19:17" ) # set self.Wheels
        self.crypto = ""
        self.DEBUG = DEBUG
        self.ThresHold = 0.1
        self.Cage = {}

    def setDebug(self, DEBUG):
        self.DEBUG = DEBUG

    def setThresHold(self, ThresHold ):
        self.ThresHold = ThresHold

    def setWheels(self, WheelsSizeTxt ):
        tb = WheelsSizeTxt.split(":")
        tb = list( map (int, tb))
        self.Wheels = []
        for aWheelSize in tb:
            self.Wheels.append( WHEEL( aWheelSize ))
            
    def setCrypto(self, crypto ):
        self.crypto = crypto
        self.STATE = "CRYPTO"

    def setWheelsPinXY(self, NUM_WHEEL, XY ):
        self.Wheels[NUM_WHEEL].PinXY[0] = XY.split(":")

    # ---- calculate Frequencies
    def calFreq(self, NUM_WHEEL):
        # ---- initilizations
        WHEEL_SIZE = self.Wheels[ NUM_WHEEL ].getSize()
        DEBUG = self.DEBUG
        # >>>>>>>> reinit (is it smart ?)
        self.Wheels[NUM_WHEEL].__init__(WHEEL_SIZE)
        self.Wheels[NUM_WHEEL].STATE[0] = 1

        # ---- calculate letters frequencies of each column
        for i in range( len(self.crypto)):
            num_lettre = string.uppercase.find( self.crypto[i] )
            num_colone = i % WHEEL_SIZE
            self.Wheels[NUM_WHEEL].Freq[ str(num_colone) ][ num_lettre ] += 1

        # ---- Chi2 calculation
        somme = 0 ; nb = 0
        unchi = self.Wheels[ NUM_WHEEL ].Chi2
        for i in range( WHEEL_SIZE):
            for j in range( WHEEL_SIZE ):
                if i != j:
                    cle  = "%2s-%2s" % (str(i),str(j))
                    cle2 = "%2s-%2s" % (str(j),str(i))
                    if cle2 in unchi: continue
                    t1 = self.Wheels[NUM_WHEEL].Freq[ str(i) ]
                    t2 = self.Wheels[NUM_WHEEL].Freq[ str(j) ]
                    unchi[cle] = chi2( t1, t2 )
                    somme += unchi[cle] ; nb += 1
        if DEBUG:
            print "Moyenne", somme / float(nb)
        self.STATE = "FREQ"

    def calPinArray(self, NUM_WHEEL):
        if self.Wheels[NUM_WHEEL].STATE[0] == 0:
            print "You need to Calculate Frequencies and Chi2 first"
            return
        self.Wheels[NUM_WHEEL].STATE[1] = 1
        WHEEL_SIZE = self.Wheels[ NUM_WHEEL ].getSize()
        chi = self.Wheels[NUM_WHEEL].Chi2
        pins = self.Wheels[NUM_WHEEL].PinXY
        tb = self.Wheels[NUM_WHEEL].Freq
        DEBUG = self.DEBUG

        # --- Find the smallest Chi2 
        #     (then the two members have a different class)
        aTb = []
        aSum = 0 ; nV = 0
        tF = 0 ; tL = 1000
        for cle in chi.keys():
            aTb.append( [cle,chi[cle]] )
            aSum += chi[cle] ; nV += 1
            if chi[cle] > tF : tF = chi[cle]
            if chi[cle] < tL : tL = chi[cle]
        aTb.sort(key=getV)
        aver = aSum / nV
        diff = (tF-aver)*self.ThresHold
        Seuil = aver + diff
        if DEBUG:
            print "The first: ", aTb[0][1], aTb[0][0]
            print " N: ", nV, "Threhold(s): ", self.ThresHold, diff
        print "Average, Best, Worst, Threshold: ",aver, tF, tL, Seuil

        # --- Create the Array of Pins and the first couple
        cle = aTb[0][0]
        xCh,yCh = cle.split("-")
        x = int(xCh) ; y = int(yCh)
        pins[0][x]="X" ; pins[0][y]="Y" ; pins[1][x]=1; pins[1][y]=1
        if DEBUG:
            print "The first couple: ", pins
        tb["X"] = list(tb[str(x)]) ; tb["Y"] = list(tb[str(y)])

        # --- Iterative way
        for i in range(WHEEL_SIZE-2):
            # --- we calculate X:n and Y:n
            maxChi = 0 ; x_true = 0 ; maxIndx = 0 ; maxDiff = 0
            for j in range(WHEEL_SIZE):
                good = 0
                if pins[1][j] != 0 : continue
                cleX = "X-" + str(j)
                achiX = chi2( tb["X"], tb[str(j)] )
                #print cleX, achiX , 
                if achiX > maxChi :
                    maxChi = achiX ; x_true = 1 ; maxIndx = j ; good = 1
                cleY = "Y-" + str(j)
                achiY = chi2( tb["Y"], tb[str(j)] )
                #print cleY, achiY ,
                if achiY > maxChi:
                    maxChi = achiY ; x_true = 0 ; maxIndx = j ; good = 1
                cleY = "Y-" + str(j)
                achiY = chi2( tb["Y"], tb[str(j)] )
                #print cleY, achiY, 
            if DEBUG:
                print "max: ", maxChi, "x/y: ", x_true, " Index: ", maxIndx, 
            if DEBUG:
                print " Max Chi2: ", maxChi, Seuil
            if maxChi >= Seuil:
                if x_true:
                    pins[0][maxIndx]="X"
                else:
                    pins[0][maxIndx]="Y"
            pins[1][maxIndx]=maxChi

            # --- merge alphabets
            if maxChi >= Seuil:
                if x_true:
                    tb["X"] = addAlpha( tb["X"], tb[str(maxIndx)] )
                else:
                    tb["Y"] = addAlpha( tb["Y"], tb[str(maxIndx)] )

        if DEBUG:
            print "Pins:", pins
        print "You can print the Pins array (option 12)"

    def calFreq2W(self, NUM_WHEEL, OTHER_WHEEL):
        # ---- test State, create Temporary Objects 
        if self.STATE == "UNDEF": return
        WHEEL_SIZE = self.Wheels[ NUM_WHEEL ].getSize()
        WH_SIZE_2W = self.Wheels[ OTHER_WHEEL ].getSize()
        DEBUG = self.DEBUG
        Freq2W = {}
        for i in range( WHEEL_SIZE ):
            v1 = list( [0] * LEN_ALPHA  )  #-- Freq "a"
            v2 = list( [0] * LEN_ALPHA  )  #-- Freq "b"
            Freq2W[str(i)] = [ v1, v2 ]

        # ---- calcul des frequences de distributions des x colonnes
        unknown = 0
        for i in range( len(self.crypto)):
            num_lettre = string.uppercase.find( self.crypto[i] )
            num_colone = i % WHEEL_SIZE
            num_col_2w = i % WH_SIZE_2W
            xORy = self.Wheels[ OTHER_WHEEL ].PinXY[0][ num_col_2w ]
            if xORy == "X":
                Freq2W[ str(num_colone) ][0][ num_lettre ] += 1
            else:
                if xORy == "Y":
                    Freq2W[ str(num_colone) ][1][ num_lettre ] += 1
                else:
                    unknown += 1
        if 1:
            for i in range(WHEEL_SIZE):
                print "(#%3d)" % (i),
                print "------------------------------------------"
                tb = Freq2W[ str(i) ][0]  # ---- "a"
                imprHisto(tb, "a")
                tb = Freq2W[ str(i) ][1]  # ---- "b"
                imprHisto(tb, "b")

        # ---- calcul des Chi2 (...et la suite)
        #DEBUG = False 
        pins = []
        for k in range(2):
          if k == 0: distri = "a"
          if k == 1: distri = "b"
          somme = 0 ; nb = 0
          unchi = {}
          tb = {}
          for i in range( WHEEL_SIZE):
            tb[ str(i) ] = Freq2W[ str(i) ][k]
            for j in range( WHEEL_SIZE ):
                if i != j:
                    cle = "%s-%s" % (str(i),str(j))
                    cle2 = "%s-%s" % (str(j),str(i))
                    if cle2 in unchi: continue
                    t1 = Freq2W[ str(i) ][k]
                    t2 = Freq2W[ str(j) ][k]
                    unchi[cle] = chi2( t1, t2 )
                    if DEBUG:
                        print i, j, cle, unchi[cle]
                    somme += unchi[cle] ; nb += 1
          if DEBUG:
            print "Moyenne", somme / float(nb)
          self.STATE = "FREQ"

          chi = unchi
          pins.append([ ["?"]*WHEEL_SIZE, [0]*WHEEL_SIZE  ])

          # --- Find the smallest Chi2
          #     (then the two members have a different class)
          aTb = []
          aSum = 0; nV = 0
          tF = 0 ; tL = 0
          for cle in chi.keys():
            aTb.append( [cle,chi[cle]] )
            aSum += chi[cle] ; nV += 1
            if chi[cle] > tF: tF = chi[cle]
            if chi[cle] < tL: tL = chi[cle]
          aTb.sort(key=getV)
          aver = aSum / nV
          Seuil = aver + (tF-aver)*self.ThresHold
          if DEBUG:
            print "The first: ", aTb[0][1], aTb[0][0]
          print "Average, Best, Worst, Threshold: ",aver, tF, tL, Seuil

          # --- Create the Array of Pins and the first couple
          cle = aTb[0][0]
          xCh,yCh = cle.split("-")
          x = int(xCh) ; y = int(yCh)
          pins[k][0][x]="X" ; pins[k][0][y]="Y" ; pins[k][1][x]=1; pins[k][1][y]=1
          if DEBUG:
            print "The first couple: ", pins[k]
          tb["X"] = list(tb[str(x)]) ; tb["Y"] = list(tb[str(y)])

          # --- Iterative way
          for i in range(WHEEL_SIZE-2):
            # --- we calculate X:n and Y:n
            maxChi = 0 ; x_true = 0 ; maxIndx = 0 ; maxDiff = 0
            for j in range(WHEEL_SIZE):
                good = 0
                if pins[k][1][j] != 0 : continue
                cleX = "X-" + str(j)
                achiX = chi2( tb["X"], tb[str(j)] )
                if achiX > maxChi :
                    maxChi = achiX ; x_true = 1 ; maxIndx = j ; good = 1
                cleY = "Y-" + str(j)
                achiY = chi2( tb["Y"], tb[str(j)] )
                if achiY > maxChi:
                    maxChi = achiY ; x_true = 0 ; maxIndx = j ; good = 1
                cleY = "Y-" + str(j)
                achiY = chi2( tb["Y"], tb[str(j)] )
            if DEBUG:
                print "max: ", maxChi, "x/y: ", x_true, " Index: ", maxIndx,
            if maxChi > Seuil:
                if x_true:
                    pins[k][0][maxIndx]="X"
                else:
                    pins[k][0][maxIndx]="Y"
            pins[k][1][maxIndx]=maxChi

            # --- merge alphabets
            if maxChi > Seuil:
                if x_true:
                    tb["X"] = addAlpha( tb["X"], tb[str(maxIndx)] )
                else:
                    tb["Y"] = addAlpha( tb["Y"], tb[str(maxIndx)] )
          print "-------> ",distri, " distribution --"
          print "1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6"
          for i in range(WHEEL_SIZE):
              print pins[k][0][i],
          print
          print "1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6"
          for i in range(WHEEL_SIZE):
              print "%4.3f(%d)," % (pins[k][1][i],i+1),
          print
        print "-------> current distribution"
        for i in range(WHEEL_SIZE):
            print self.Wheels[NUM_WHEEL].PinXY[0][i],
        print
        for i in range(WHEEL_SIZE):
            print "%4.3f" % (self.Wheels[NUM_WHEEL].PinXY[1][i]),
        print
        print "WARNING! The value (X or Y) can be inversed";
        print "Now, you can choose menu to modify Pins setting (choice 10)";

    def modPinXY( self, NUM_WHEEL ):
        WHEEL_SIZE = self.Wheels[ NUM_WHEEL ].getSize()
        for i in range(WHEEL_SIZE):
            print "Current Value of Column ", i+1, ":",
            print self.Wheels[NUM_WHEEL].PinXY[0][i], ",",
            print self.Wheels[NUM_WHEEL].PinXY[1][i]
            print " New Value (X|Y|?),value, example: X,0.06, return == continue ",
            ch = raw_input(" ? ")
            if ch == "": continue
            xORy,aChi2 = ch.split(",")
            self.Wheels[NUM_WHEEL].PinXY[0][i] = xORy
            self.Wheels[NUM_WHEEL].PinXY[1][i] = float(aChi2)

    def calCage( self ):
        unknown = 0
        for i in range( len(self.crypto)):
            num_lettre = string.uppercase.find( self.crypto[i] )
            key = ""
            indxGood = True
            for j in range( len(self.Wheels)):
                WHEEL_SIZE = self.Wheels[j].getSize()
                num_colone = i % WHEEL_SIZE
                xORy = self.Wheels[ j ].PinXY[0][ num_colone ]
                if xORy == "?": 
                    indxGood = False
                    break
                key += xORy
            if indxGood:
                if key in self.Cage:
                    self.Cage[key][num_lettre] += 1
                else:
                    self.Cage[key] = [0]*26
            else:
                unknown += 1
        print "Unknown: ", unknown
        for key,value in self.Cage.items():
            print "Cage: ", key
            #imprHisto( value, " ")
            theShift( Barker.freq_plain, value , self.DEBUG )

    def impFreq( self, NUM_WHEEL ):
        WHEEL_SIZE = self.Wheels[ NUM_WHEEL ].getSize()
        for i in range(WHEEL_SIZE):
            print "(#%3d)" % (i+1)
            tb = self.Wheels[NUM_WHEEL].Freq[ str(i) ]
            imprHisto(tb, " ")

    def impChi2( self, NUM_WHEEL ):
        WHEEL_SIZE = self.Wheels[ NUM_WHEEL ].getSize()
        dico = self.Wheels[NUM_WHEEL].Chi2
        i = 0
        for x in sorted( dico ):
            c1,c2 = x.split("-")
            print "#%2d + #%-2d = %5.3f  " % (int(c1)+1,int(c2)+1, dico[x]),
            i += 1
            if (i%4) == 0 and (i!=0): print

    def imprPinXY( self, NUM_WHEEL ):
        WHEEL_SIZE = self.Wheels[ NUM_WHEEL ].getSize()
        for i in range(WHEEL_SIZE):
            print self.Wheels[NUM_WHEEL].PinXY[0][i],
        print
        for i in range(WHEEL_SIZE):
            print "%4.3f" % (self.Wheels[NUM_WHEEL].PinXY[1][i]),
        print
